;################################################################################################
; NCSysMetrics, v.2008-03-03
; http://www.geocities.com/xmemor/2lz/tinyasm.html
; ("Tiny apps + sources (masm32)")
;################################################################################################

.386
.model flat,stdcall
option casemap:none

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib  user32
inclib  kernel32
inclib  gdi32
inclib  comctl32

.const
 id               equ 2000
 Dlg1             equ 101
 Dlg2             equ 102
 iSmCaptionHeight equ iSMCaptionHeight
 iSmCaptionWidth  equ iSMCaptionWidth
 lfSmCaptionFont  equ lfSMCaptionFont
 
.data
 _mdichild        db " NCSysMetrics  by  kero,  v.2008-03-03",0, "<geocities.com/xmemor>",0
 _mfont           db "This is MessageFont",0
 _mesbox          db "MessageBox",0
 _mdiclient       db "mdiclient",0
 _TaskbarCreated  db "TaskbarCreated",0
 _statusbar32     db "msctls_statusbar32",0
 sm_ \
                  dd SM_CYBORDER
                  dd SM_CXBORDER
                  dd SM_CYEDGE
                  dd SM_CXEDGE
                  dd SM_CYFIXEDFRAME
                  dd SM_CXFIXEDFRAME
                  dd SM_CYSIZEFRAME
                  dd SM_CXSIZEFRAME
                  dd SM_CYCAPTION
                  dd SM_CYSIZE
                  dd SM_CXSIZE
                  dd SM_CYSMCAPTION
                  dd SM_CYSMSIZE
                  dd SM_CXSMSIZE
                  dd SM_CYMENU
                  dd SM_CYMENUSIZE
                  dd SM_CXMENUSIZE
                  dd SM_CYVTHUMB
                  dd SM_CXHTHUMB
                  dd SM_CYVSCROLL
                  dd SM_CXHSCROLL
                  dd SM_CYHSCROLL
                  dd SM_CXVSCROLL
.data?
 hinst            HINSTANCE ?
 ncm              NONCLIENTMETRICS <>
 lgfnt            LOGFONT <>
 TaskbarCreated   dd ?
 SPI_wParam       dd ?
 SPI_lParam       dd ?

.code

;################################################################################################

EnumFontFamExProc proc lpelfe:DWORD,lpntme:DWORD,FontType:DWORD,hWnd:DWORD
  add lpelfe,4*7  ; ENUMLOGFONTEX(DV) <LOGFONT <...lfFaceName...>...>
  invoke SendMessage,hWnd,CB_FINDSTRING,-1,lpelfe
  .if eax==CB_ERR
    invoke SendMessage,hWnd,CB_ADDSTRING,0,lpelfe
  .endif
  xor eax,eax
  inc eax
  ret
EnumFontFamExProc endp

;################################################################################################

FontListCombo proc uses ebx hWnd:HWND
  local lf:LOGFONT
  invoke SendMessage,hWnd,CB_RESETCONTENT,0,0
  invoke GetDC,0
  mov ebx,eax
  mov lf.lfCharSet,DEFAULT_CHARSET
  mov lf.lfFaceName,0
  mov lf.lfPitchAndFamily,0
  invoke EnumFontFamiliesEx,ebx,addr lf,addr EnumFontFamExProc,hWnd,0
  invoke ReleaseDC,0,ebx  
  ret
FontListCombo endp

;################################################################################################

MDImenu proc hWnd:HWND
  local wc:WNDCLASSEX
  local clientcreate:CLIENTCREATESTRUCT
  local mdicreate:MDICREATESTRUCT
  mov wc.cbSize,sizeof WNDCLASSEX
  mov wc.style,0
  mov wc.cbClsExtra,0
  mov wc.cbWndExtra,0
  mov eax,hinst
  mov wc.hInstance,eax
  mov wc.lpszMenuName,0
  mov wc.hIcon,0
  mov wc.hIconSm,0
  invoke LoadCursor,0,IDC_ARROW
  mov wc.hCursor,eax
  mov wc.lpfnWndProc,DefMDIChildProc
  mov wc.hbrBackground,COLOR_WINDOW
  mov wc.lpszClassName,offset _mdichild
  invoke RegisterClassEx,addr wc
  mov mdicreate.szClass,offset _mdichild
  mov mdicreate.szTitle,0
  mov eax,hinst
  mov mdicreate.hOwner,eax
  mov mdicreate.style,WS_MAXIMIZE
  invoke GetMenu,hWnd
  invoke GetSubMenu,eax,1
  mov clientcreate.hWindowMenu,eax
  mov clientcreate.idFirstChild,0
  invoke CreateWindowEx,0,offset _mdiclient,0,WS_CHILD,0,0,0,0,hWnd,0,hinst,addr clientcreate
  mov ecx,eax
  invoke SendMessage,ecx,WM_MDICREATE,0,addr mdicreate
  ret
MDImenu endp

;################################################################################################

GetInfo proc uses ebx hWnd:HWND
  local var:DWORD
  invoke SystemParametersInfo,SPI_GETNONCLIENTMETRICS,ncm.cbSize,addr ncm,0
  invoke SystemParametersInfo,SPI_GETICONTITLELOGFONT,sizeof LOGFONT,addr lgfnt,0
  xor eax,eax
  push offset ncm.lfMessageFont.lfFaceName
  push offset ncm.lfStatusFont.lfFaceName
  push offset ncm.lfMenuFont.lfFaceName
  push offset ncm.lfSmCaptionFont.lfFaceName
  push offset ncm.lfCaptionFont.lfFaceName
  push offset lgfnt.lfFaceName
  mov al,lgfnt.lfCharSet
  push eax
  push lgfnt.lfHeight
  mov al,ncm.lfMessageFont.lfCharSet
  push eax
  mov al,ncm.lfStatusFont.lfCharSet
  push eax
  mov al,ncm.lfMenuFont.lfCharSet
  push eax
  mov al,ncm.lfSmCaptionFont.lfCharSet
  push eax
  mov al,ncm.lfCaptionFont.lfCharSet
  push eax
  push ncm.lfMessageFont.lfHeight
  push ncm.lfStatusFont.lfHeight
  push ncm.lfMenuFont.lfHeight
  push ncm.lfSmCaptionFont.lfHeight
  push ncm.lfCaptionFont.lfHeight
  push ncm.iScrollWidth
  push ncm.iScrollHeight
  push ncm.iMenuWidth
  push ncm.iMenuHeight
  push ncm.iSmCaptionWidth
  push ncm.iSmCaptionHeight
  push ncm.iCaptionWidth
  push ncm.iCaptionHeight
  push ncm.iBorderWidth
  invoke SystemParametersInfo,SPI_GETBORDER,0,addr var,0
  push var
  xor ebx,ebx
  .while ebx<51
    .if ebx<23
      mov eax,offset sm_
      mov edx,dword ptr [eax+4*ebx]
      invoke GetSystemMetrics,edx
    .else
      pop eax
    .endif
    mov edx,id
    add edx,ebx
    .if ebx<=44
      invoke SetDlgItemInt,hWnd,edx,eax,1
    .else
      invoke SetDlgItemText,hWnd,edx,eax
    .endif
    inc ebx
  .endw
  ret
GetInfo endp

;################################################################################################

SetInfo proc uses ebx hWnd:HWND
  mov ebx,id+24
  .while ebx<id+45
    invoke GetDlgItemInt,hWnd,ebx,0,1
    push eax
    inc ebx
  .endw
  pop eax
  mov lgfnt.lfCharSet,al
  pop lgfnt.lfHeight
  pop eax
  mov ncm.lfMessageFont.lfCharSet,al
  pop eax
  mov ncm.lfStatusFont.lfCharSet,al
  pop eax
  mov ncm.lfMenuFont.lfCharSet,al
  pop eax
  mov ncm.lfSmCaptionFont.lfCharSet,al
  pop eax
  mov ncm.lfCaptionFont.lfCharSet,al
  pop ncm.lfMessageFont.lfHeight
  pop ncm.lfStatusFont.lfHeight
  pop ncm.lfMenuFont.lfHeight
  pop ncm.lfSmCaptionFont.lfHeight
  pop ncm.lfCaptionFont.lfHeight
  pop ncm.iScrollWidth
  pop ncm.iScrollHeight
  pop ncm.iMenuWidth
  pop ncm.iMenuHeight
  pop ncm.iSmCaptionWidth
  pop ncm.iSmCaptionHeight
  pop ncm.iCaptionWidth
  pop ncm.iCaptionHeight
  pop ncm.iBorderWidth
  push offset ncm.lfMessageFont.lfFaceName
  push offset ncm.lfStatusFont.lfFaceName
  push offset ncm.lfMenuFont.lfFaceName
  push offset ncm.lfSmCaptionFont.lfFaceName
  push offset ncm.lfCaptionFont.lfFaceName
  push offset lgfnt.lfFaceName
  .while ebx<id+51
    pop eax
    invoke GetDlgItemText,hWnd,ebx,eax,32
    inc ebx
  .endw
  invoke SystemParametersInfo,SPI_SETICONTITLELOGFONT,sizeof LOGFONT,addr lgfnt,0
  invoke SystemParametersInfo,SPI_SETNONCLIENTMETRICS,ncm.cbSize,addr ncm,SPIF_UPDATEINIFILE OR SPIF_SENDCHANGE
  invoke PostMessage,HWND_BROADCAST,TaskbarCreated,0,0
  invoke InvalidateRect,0,0,1
  ret
SetInfo endp

;################################################################################################

TransmitToDescendants proc hWnd:HWND,param:DWORD
  local buf[256]:BYTE
  invoke RealGetWindowClass,hWnd,addr buf,255
  invoke lstrcmpi,addr buf,param
  .if eax==0
    invoke SendMessageTimeout,hWnd,WM_SETTINGCHANGE,SPI_wParam,SPI_lParam,SMTO_ABORTIFHUNG,300,0
  .endif
  xor eax,eax
  inc eax
  ret
TransmitToDescendants endp

;################################################################################################

DlgProc proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  local buf[256]:BYTE
  
  .if uMsg==WM_CLOSE
    invoke EndDialog,hWnd,0
    
  .elseif uMsg==WM_SIZE
    invoke GetDlgItem,hWnd,id-100
    mov ebx,eax
    invoke SendMessage,ebx,uMsg,0,0
    invoke SetWindowPos,ebx,HWND_TOP,0,0,0,0,SWP_NOSIZE OR SWP_NOMOVE OR SWP_FRAMECHANGED
    invoke InvalidateRect,ebx,0,1

  .elseif uMsg==WM_MOUSEWHEEL
    xor esi,esi
    .if wParam<80000000h
      dec esi
    .else
      inc esi
    .endif  
    mov eax,lParam
    mov ecx,eax
    and eax,0ffffh
    shr ecx,16
    invoke WindowFromPoint,eax,ecx
    mov ebx,eax    
    invoke IsChild,hWnd,ebx
    .if eax!=0 && ebx!=hWnd
      invoke GetWindowLong,ebx,GWL_ID
      mov edi,eax
      and edi,0ffffh
      .if edi>=id+24 && edi<=id+44
        invoke GetDlgItemInt,hWnd,edi,0,1
        sub eax,esi
        invoke SetDlgItemInt,hWnd,edi,eax,1
        jmp @f
      .elseif edi>=id+45 && edi<=id+50
        invoke GetDlgItemText,hWnd,edi,addr buf,255
        invoke SendDlgItemMessage,hWnd,id-6,CB_FINDSTRING,-1,addr buf
        .if eax!=CB_ERR
          add esi,eax
@0:
          invoke SendDlgItemMessage,hWnd,id-6,CB_GETLBTEXT,esi,addr buf         
          invoke SetDlgItemText,hWnd,edi,addr buf
          jmp @f
        .else
          xor eax,eax
          jmp @0
        .endif
      .endif
    .endif
    
  .elseif uMsg==WM_COMMAND && (wParam==id-2 || wParam==id-1)
@@:
    invoke SetInfo,hWnd
    jmp @f

  .elseif uMsg==WM_COMMAND && wParam==id-5
    invoke MessageBox,hWnd,addr _mfont,addr _mesbox,MB_TOPMOST

  .elseif uMsg==WM_SETTINGCHANGE
    mov eax,wParam
    mov SPI_wParam,eax
    mov eax,lParam
    mov SPI_lParam,eax
    invoke SendDlgItemMessage,hWnd,id-3,BM_GETCHECK,0,0
    .if eax!=0
      invoke GetDesktopWindow
      mov ebx,eax
      invoke EnumChildWindows,ebx,addr TransmitToDescendants,offset _statusbar32
    .endif
    jmp @f    

  .elseif uMsg==WM_INITDIALOG
    invoke GetDlgItem,hWnd,id-6
    mov ebx,eax
    invoke ShowWindow,ebx,SW_HIDE
    invoke FontListCombo,ebx
    invoke CreateStatusWindow,SBARS_SIZEGRIP or SBT_TOOLTIPS or WS_CHILD or WS_VISIBLE OR WS_CLIPSIBLINGS,0,hWnd,id-100
    mov ecx,eax
    invoke SetWindowText,ecx,addr _mdichild
    invoke RegisterWindowMessage,offset _TaskbarCreated
    mov TaskbarCreated,eax
    invoke MDImenu,hWnd
    invoke CreateDialogParam,hinst,Dlg2,hWnd,0,0
    mov ebx,eax
    invoke SetParent,ebx,hWnd
    invoke SetWindowPos,ebx,0,230,16,0,0,SWP_NOZORDER OR SWP_NOSIZE OR SWP_FRAMECHANGED
    invoke SendDlgItemMessage,hWnd,id-3,BM_SETCHECK,BST_CHECKED,0
    mov ncm.cbSize,sizeof NONCLIENTMETRICS
@@:
    invoke GetInfo,hWnd

  .elseif uMsg==WM_CTLCOLORSTATIC
    invoke GetWindowLong,lParam,GWL_ID
    and eax,0ffffh
    .if eax==id-1
      invoke SetTextColor,wParam,Blue
      invoke SetBkMode,wParam,TRANSPARENT
      invoke GetStockObject,NULL_BRUSH
      jmp @f
    .else
      jmp @@@
    .endif
    
  .elseif uMsg==WM_SETCURSOR
    mov ebx,wParam
    .if ebx==hWnd
      invoke IsWindowEnabled,ebx
      .if eax==0
        inc eax
        invoke EnableWindow,ebx,eax
      .endif
    .endif
    invoke GetWindowLong,ebx,GWL_ID
    and eax,0ffffh
    .if eax>=id+24 && eax<=id+50
      invoke SetFocus,ebx
    .endif
    jmp @@@
    
  .else
@@@:
    xor eax,eax
    jmp @f
  .endif
  xor eax,eax
  inc eax
@@:
  ret
DlgProc endp

;################################################################################################

start:
  invoke GetModuleHandle,0
  mov hinst,eax
  invoke DialogBoxParam,hinst,Dlg1,0,offset DlgProc,0
  invoke ExitProcess,eax
  invoke InitCommonControls
end start

;################################################################################################
